# mailscanner-lib.pl

do '../web-lib.pl';
&init_config();

$mailscanner_path = &has_command($config{'mailscanner'});
$mailscanner_config_file = "$config{'mailscanner_config'}";

# get_mailscanner_config()
# Returns a list of values from the MailScanner config file

sub get_mailscanner_config
{
local @rv;
local $lnum = -1;
open(CONFIG, $mailscanner_config_file);
while(<CONFIG>) {

     $lnum++;
     #next if /^[\s#]/;

     chomp;
     #s/#.*$//;
     s/^\s+//;
     s/\s+$//;
     next if /^$/;

     undef $origkey;
     undef $key;
     undef $value;
     /^(.*?)\s*=\s*(.*)$/;
     #/^(.*)\s+=\s+(.*)$/;
     ($origkey,$value) = ($1,$2);

     $key = lc($origkey);
     #$key =~ s/[^A-Za-z0-9]//g; # Leave numbers and letters only

     push(@rv, { 'name' => $key,
                       'value' => $value,
                       'line' => $lnum,
                       'index' => scalar(@rv) } );
	}
close(CONFIG);
return @rv;
}

# find(name, &config)
sub find
{
local ($c, @rv);
$c = lc($c);
#$c =~ s/[^A-Za-z0-9]//g;
foreach $c (@{$_[1]}) {
	push(@rv, $c) if (lc($c->{'name'}) eq lc($_[0]));
	}
return wantarray ? @rv : $rv[0];
}

# save_mailscanner_config(&config, name, value, [default])
sub save_mailscanner_config
{
local $lref = &read_file_lines($mailscanner_config_file);
local $old = &find($_[1], $_[0]);
if ($old && $_[2]) {
	# Replacing an existing config line
	$lref->[$old->{'line'}] = "$_[1] = $_[2]";
	}
#elsif ($old) {
#	# Deleting a config line (unless it already exists with the default)
#	if (!$_[3] || $old->{'value'} ne $_[3]) {
#		splice(@$lref, $old->{'line'}, 1);
#		local $c;
#		foreach $c (@{$_[0]}) {
#			$c->{'line'}-- if ($c->{'line'} > $old->{'line'});
#			}
#		}
#	}
elsif ($_[2]) {
	# Adding a config line
	push(@$lref, "$_[1] = $_[2]");
	}
}

1;

